// font

import std.stdio;
import std.utf: toUCSindex;
import core.vararg;

import wcw.auxiliary;
import painter;

struct LN
{
	short[] p;

	this (short[] ub...) {p = ub.dup;}
}

struct AC
{
	short x, y, d;
	short a0, a1;
}

struct CH
{
	dchar[] l;
	this (dchar[] c...) {l = c.dup;}
}

struct LT
{
	LN[] lines;
	AC[] arcs;
	CH[] chars;

	this (...)
	{
		foreach (a; _arguments)
		{
			if      (a == typeid(LN)) lines ~= va_arg!(LN)(_argptr);
			else if (a == typeid(AC)) arcs ~= va_arg!(AC)(_argptr);
			else if (a == typeid(CH)) chars ~= va_arg!(CH)(_argptr);
			else                      assert (0);
		}
	}
}

struct FT
{
	double width;
	double height;
	double base;

	LT[dchar] letters;
}

class WDFont
{
	FT* _font;
	double _ratio;


	this (FT* font)
	{
		_font = font;
	}

	double width () const {return _font.width;}
	double height () const {return _font.height;}
	double base () const {return _font.base;}

	double width (cstring txt) const
	{
		return txt.toUCSindex(txt.length) * width;
	}

	const (LT) letter (dchar c) const
	{
		if (c in _font.letters) return _font.letters[c];
		else                    return _font.letters[0];
	}
}

private static FT static_df;
static WDFont defaultFont;

shared static this()
{
	static_df = FT(16, 36, 8,
	[
/* 0000	*/	0: LT(LN(1,1,15,1,15,35,1,35,1,1)),

/* 0020 */	' ': LT(),
/* 0021 */	'!': LT(AC(8,31,2,0,180),LN(7,31,8,12,9,31),AC(8,9,2,0,360)),
/* 0022 */	'"': LT(AC(5,31,2,0,180),LN(4,31,4,27,6,31),AC(11,31,2,0,180),LN(10,31,10,27,12,31)),
/* 0023 */	'#': LT(LN(2,8,6,32),LN(10,8,14,32),LN(2,16,14,16),LN(2,24,14,24)),
/* 0024 */	'$': LT(CH('S'),LN(8,6,8,34)),
/* 0025 */	'%': LT(AC(5,29,6,0,360),AC(11,11,6,0,360),LN(2,8,14,32)),
/* 0026 */	'&': LT(AC(8,14,12,92,360),AC(8,26,12,0,147),LN(14,8,3,29)),
/* 0027 */	'\'': LT(AC(8,31,2,0,180),LN(7,31,8,27,9,31)),
/* 0028 */	'(': LT(AC(19,20,30,113,247)),
/* 0029 */	')': LT(AC(-3,20,30,-67,67)),
/* 002a */	'*': LT(LN(8,14,8,26),LN(3,23,13,17),LN(3,17,13,23)),
/* 002b */	'+': LT(LN(2,20,14,20),LN(8,14,8,26)),
/* 002c */	',': LT(AC(8,9,2,0,180), LN(7,9,7,5,9,9)),
/* 002d */	'-': LT(LN(2,20,14,20)),
/* 002e */	'.': LT(AC(8,9,2,0,360)),
/* 002f */	'/': LT(LN(2,6,14,34)),

/* 0030 */	'0': LT(CH('O'),LN(3,11,13,29)),
/* 0031 */	'1': LT(LN(2,26,8,32,8,8),LN(2,8,14,8)),
/* 0032 */	'2': LT(LN(14,8,2,8,2,12),LN(14,24,14,26),LN(8,32,7,32),AC(10,12,16,90,180),AC(10,24,8,270,0),AC(8,26,12,0,90),AC(7,26,12,90,150)),
/* 0033 */	'3': LT(LN(7,8,8,8),LN(7,32,8,32),AC(7,14,12,210,270),AC(8,14,12,270,90),AC(8,26,12,270,90),AC(7,26,12,90,150)),
/* 0034 */	'4': LT(LN(11,8,11,32,2,17,14,17)),
/* 0035 */	'5': LT(LN(14,14,14,16),LN(8,22,2,22,2,32,14,32),AC(8,14,12,180,0),AC(8,16,12,0,90)),
/* 0036 */	'6': LT(LN(2,14,2,26),LN(8,32,9,32),LN(14,14,14,16),AC(8,14,12,180,0),AC(8,16,12,0,180),AC(8,26,12,90,180),AC(9,26,12,45,90)),
/* 0037 */	'7': LT(LN(4,8,14,32,2,32)),
/* 0038 */	'8': LT(AC(8,14,12,0,360),AC(8,26,12,0,360)),
/* 0039 */	'9': LT(LN(14,14,14,26),LN(7,8,8,8),LN(2,24,2,26),AC(8,26,12,0,180),AC(8,24,12,180,0),AC(7,14,12,225,270),AC(8,14,12,270,0)),
/* 003a */	':': LT(AC(8,21,2,0,360), CH('.')),
/* 003b */	';': LT(AC(8,21,2,0,360), CH(',')),
/* 003c */	'<': LT(LN(14,26,2,20,14,14)),
/* 003d */	'=': LT(LN(2,18,14,18),LN(2,22,14,22)),
/* 003e */	'>': LT(LN(2,26,14,20,2,14)),
/* 003f */	'?': LT(AC(8,26,12,-90,180),LN(8,20,8,12),AC(8,9,2,0,360)),

/* 0040 */	'@': LT(AC(8,14,12,180,315),AC(8,26,12,0,180),LN(2,14,2,26),LN(14,13,14,26),AC(9,19,10,180,360),AC(9,21,10,0,180),LN(4,19,4,21)),
/* 0041 */	'A': LT(LN(1,8,8,32,15,8),LN(4,18,12,18)),
/* 0042 */	'B': LT(LN(9,8,2,8,2,32,8,32),LN(2,20,9,20),AC(9,14,12,270,90),AC(8,26,12,270,90)),
/* 0043 */	'C': LT(LN(2,15,2,25),AC(9,15,14,180,320),AC(9,25,14,40,180)),
/* 0044 */	'D': LT(LN(7,8,2,8,2,32,8,32),LN(14,15,14,25),AC(7,15,14,270,0),AC(7,25,14,0,90)),
/* 0045 */	'E': LT(LN(2,8,14,8),CH('F')),
/* 0046 */	'F': LT(LN(2,8,2,32,14,32),LN(2,20,10,20)),
/* 0047 */	'G': LT(LN(8,20,14,20,14,14),LN(2,14,2,26),AC(8,14,12,180,0),AC(8,26,12,0,180)),
/* 0048 */	'H': LT(LN(2,8,2,32),LN(14,8,14,32),LN(2,20,14,20)),
/* 0049 */	'I': LT(LN(2,8,14,8),LN(2,32,14,32),LN(8,8,8,32)),
/* 004a */	'J': LT(LN(14,14,14,32),AC(8,14,12,180,0)),
/* 004b */	'K': LT(LN(2,8,2,32),LN(2,20,14,32),LN(2,20,14,8)),
/* 004c */	'L': LT(LN(2,32,2,8,14,8)),
/* 004d */	'M': LT(LN(2,8,2,32,8,20,14,32,14,8)),
/* 004e */	'N': LT(LN(2,8,2,32,14,8,14,32)),
/* 004f */	'O': LT(LN(2,14,2,26),LN(14,14,14,26),AC(8,14,12,180,0),AC(8,26,12,0,180)),

/* 0050 */	'P': LT(LN(2,8,2,32,8,32),LN(2,20,8,20),AC(8,26,12,270,90)),
/* 0051 */	'Q': LT(CH('O'),LN(10,12,14,8)),
/* 0052 */	'R': LT(CH('P'),LN(2,20,14,8)),
/* 0053 */	'S': LT(AC(8,14,12,180,90),AC(8,26,12,0,270)),
/* 0054 */	'T': LT(LN(2,32,14,32),LN(8,8,8,32)),
/* 0055 */	'U': LT(LN(2,14,2,32),LN(14,14,14,32),AC(8,14,12,180,0)),
/* 0056 */	'V': LT(LN(2,32,8,8,14,32)),
/* 0057 */	'W': LT(LN(1,32,4,8,8,18,12,8,15,32)),
/* 0058 */	'X': LT(LN(2,8,14,32),LN(2,32,14,8)),
/* 0059 */	'Y': LT(LN(2,8,14,32),LN(2,32,8,20)),
/* 005a */	'Z': LT(LN(2,32,14,32,2,8,14,8)),
/* 005b */	'[': LT(LN(12,6,4,6,4,34,12,34)),
/* 005c */	'\\': LT(LN(14,6,2,34)),
/* 005d */	']': LT(LN(4,6,12,6,12,34,4,34)),
/* 005e */	'^': LT(LN(2,22,8,32,14,22)),
/* 005f */	'_': LT(LN(2,0,14,0)),

/* 0060 */	'`': LT(LN(7,32,9,36)),
/* 0061 */	'a': LT(LN(14,8,14,19),LN(14,16,6,16),LN(6,8,12,8),LN(4,22,11,22),AC(6,12,8,90,270),AC(12,10,4,270,0),AC(11,19,6,0,90)),
/* 0062 */	'b': LT(LN(8,8,2,8,2,32),LN(2,22,8,22),LN(14,14,14,16),AC(8,14,12,270,0),AC(8,16,12,0,90)),
/* 0063 */	'c': LT(LN(14,8,8,8),LN(2,14,2,16),LN(8,22,14,22),AC(8,14,12,180,270),AC(8,16,12,90,180)),
/* 0064 */	'd': LT(LN(14,8,14,32),CH('c')),
/* 0065 */	'e': LT(LN(2,14,2,16,14,16),AC(8,14,12,180,320),AC(8,16,12,0,180)),
/* 0066 */	'f': LT(LN(6,8,6,26),LN(2,22,10,22),AC(12,26,12,70,180)),
/* 0067 */	'g': LT(LN(2,14,2,16),LN(14,22,14,6),AC(8,14,12,180,0),AC(8,16,12,0,180),AC(8,6,12,200,0)),
/* 0068 */	'h': LT(LN(2,8,2,32),LN(2,22,8,22),LN(14,16,14,8),AC(8,16,12,0,90)),
/* 0069 */	'i': LT(LN(2,8,13,8),LN(3,22,8,22,8,8),AC(8,27,2,0,360)),
/* 006a */	'j': LT(LN(3,22,8,22,8,6),AC(2,6,12,270,0),AC(8,27,2,0,360)),
/* 006b */	'k': LT(LN(3,8,3,32),LN(13,8,3,18,10,26)),
/* 006c */	'l': LT(LN(2,32,7,32,7,14),AC(13,14,12,180,270)),
/* 006d */	'm': LT(LN(2,8,2,22),LN(8,8,8,19),LN(14,8,14,19),AC(5,19,6,0,180),AC(11,19,6,0,180)),
/* 006e */	'n': LT(LN(3,8,3,22),LN(13,8,13,16),AC(8,16,10,0,180)),
/* 006f */	'o': LT(LN(2,14,2,16),LN(14,14,14,16),AC(8,14,12,180,0),AC(8,16,12,0,180)),

/* 0070 */	'p': LT(LN(2,0,2,22),LN(14,14,14,16),AC(8,14,12,180,0),AC(8,16,12,0,180)),
/* 0071 */	'q': LT(LN(14,0,14,22),LN(2,14,2,16),AC(8,14,12,180,0),AC(8,16,12,0,180)),
/* 0072 */	'r': LT(LN(3,8,3,22),AC(9,16,12,70,180)),
/* 0073 */	's': LT(LN(6,8,10,8),LN(13,11,13,12),LN(10,15,6,15),LN(3,18,3,19),LN(6,22,10,22),AC(6,11,6,200,270),AC(10,11,6,270,0),AC(10,12,6,0,90),AC(6,18,6,180,270),AC(6,19,6,90,180),AC(10,19,6,20,90)),
/* 0074 */	't': LT(LN(8,14,8,32),LN(4,22,15,22),AC(14,14,12,180,270)),
/* 0075 */	'u': LT(LN(3,22,3,13),LN(13,8,13,22),AC(8,13,10,180,0)),
/* 0076 */	'v': LT(LN(2,22,8,8,14,22)),
/* 0077 */	'w': LT(LN(2,22,5,8,8,14,11,8,14,22)),
/* 0078 */	'x': LT(LN(2,8,14,22),LN(2,22,14,8)),
/* 0079 */	'y': LT(LN(2,22,8,8),LN(14,22,8,8,4,0)),
/* 007a */	'z': LT(LN(2,22,14,22,2,8,14,8)),
/* 007b */	'{': LT(AC(12,30,8,90,180),AC(12,10,8,180,270),AC(4,24,8,270,360),AC(4,16,8,0,90),LN(8,24,8,30),LN(8,10,8,16)),
/* 007c */	'|': LT(LN(8,6,8,34)),
/* 007d */	'}': LT(AC(4,30,8,0,90),AC(4,10,8,270,360),AC(12,24,8,180,270),AC(12,16,8,90,180),LN(8,24,8,30),LN(8,10,8,16)),
/* 007e */	'~': LT(AC(5,29,6,0,180),AC(11,29,6,180,360)),

/* 00b0 */	'°': LT(AC(6,29,6,0,360)),
/* 00c4 */	'Ä': LT(CH('A'),AC(5,35,2,0,360), AC(11,35,2,0,360)),
/* 00d6 */	'Ö': LT(CH('O'),AC(5,35,2,0,360), AC(11,35,2,0,360)),
/* 00dc */	'Ü': LT(CH('U'),AC(5,35,2,0,360), AC(11,35,2,0,360)),
/* 00df */	'ß': LT(LN(2,6,2,25),AC(7,14,12,-90,90),AC(7,25,10,-90,180)),
/* 00e4 */	'ä': LT(CH('a'),AC(5,27,2,0,360), AC(11,27,2,0,360)),
/* 00f6 */	'ö': LT(CH('o'),AC(5,27,2,0,360), AC(11,27,2,0,360)),
/* 00fc */	'ü': LT(CH('u'),AC(5,27,2,0,360), AC(11,27,2,0,360)),
/* 2300 */	'⌀': LT(AC(8,15,14,0,360), LN(1,8,15,22)),
	]);

	defaultFont = new WDFont (&static_df);
}